
## Build the Intel(R) SGX default Quote Provider Library
- To set the environment variables, enter the following command:
```
  $ source ${SGX_PACKAGES_PATH}/sgxsdk/environment
```
- To build the Intel(R) SGX default Quote Provider Library, enter the following command:
```
   $ cd qpl/linux
   $ make
```
The target library named ``libdcap_quoteprov.so`` will be generated.

You will also need to build  Intel(R) SGX default Collateral Network Library because the Quote Provider Library depends on it:
```
   $ cd qcnl/linux
   $ make
```

The target library named ``libsgx_default_qcnl_wrapper.so`` will be generated.
 - To clean the files generated by previous `make` command, enter the following command:
```
  $ make clean
```

 - To build debug libraries, enter the following command:
```
  $ make DEBUG=1
```
## Configuration

#### Linux
The configuration file for Intel(R) SGX default Quote Provider Library under Linux is /etc/sgx_default_qcnl.conf. If it is not present, the library will use hard-coded configurations. Please check https://github.com/intel/SGXDataCenterAttestationPrimitives/blob/master/QuoteGeneration/qcnl/linux/sgx_default_qcnl.conf for details.

#### Windows
The configuration file under Windows has the same format as Linux. But you need to specifiy the location of the configuration file in Windows registry. Also make sure your program has read access to this file. For example:<br />
[HKEY_LOCAL_MACHINE\SOFTWARE\Intel\SGX\QCNL] <br />
"CONFIG_FILE"="C:\ProgramData\Intel\SGXDCAP\sgx_default_qcnl.conf" <br />